
%global meadversion 9.0.87
%global namedversion 9.0.87.redhat-00003
%global meadalpha .redhat_00003
%global meadrel .1
%global serial 3
%global namedversionrel redhat-00003

%bcond_without mead
%bcond_without zips

%define _jarsign_opts --nocopy --skip=%{basedir} --skip=%{bindir} --skip=%{_javadir} 

%define section free

%{?scl:%global nfsmountable 1}
%{?scl:%scl_package tomcat}
%{!?scl:%global pkg_name %{name}}

%define with_signing 0

%define servletspec 4.0
%define jspspec 2.3
%define elspec 3.0
%define elspecalt 3_0
%define tcuid 53
%define ecjrev 4.20.0

# FHS 2.3 compliant tree structure - http://www.pathname.com/fhs/2.3/
%define basedir %{_localstatedir}/lib/%{pkg_name}
%define appdir %{basedir}/webapps
%define homedir %{_datadir}/%{pkg_name}
%define bindir %{homedir}/bin
%define confdir %{_sysconfdir}/%{pkg_name}
%define libdir %{_javadir}/%{pkg_name}
%define logdir %{_localstatedir}/log/%{pkg_name}
%define cachedir %{_localstatedir}/cache/%{pkg_name}
%define tempdir %{cachedir}/temp
%define workdir %{cachedir}/work
#%define _initrddir %{_sysconfdir}/rc.d/init.d
%define javasigneddir %{_datadir}/java-signed
%define javaversion 1.7.0

# We need to overwrite the _file_context_* macros because they expand with the SCL prefix which results in bad file paths
%define _file_context_file %{_root_sysconfdir}/selinux/${SELINUXTYPE}/contexts/files/file_contexts
%define _file_context_file_pre %{_root_sysconfdir}/selinux/${SELINUXTYPE}/contexts/files/file_contexts.pre
%if 0%{?rhel} <= 6
    %{!?_selinux_policy_version: %global _selinux_policy_version %(sed -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' %{_datadir}/selinux/devel/policyhelp 2>/dev/null)}
%endif

%define maven_version 9.0.87.redhat-00003

Name: %{?scl_prefix}tomcat
Epoch: 0
Version: %{meadversion}
Release: %{serial}%{meadalpha}%{meadrel}%{?dist}
Summary: Apache Servlet/JSP Engine, RI for Servlet %{servletspec}/JSP %{jspspec} API
Group: Networking/Daemons

%if %with mead
Source102: tomcat-websocket-9.0.87.redhat-00003-sources.jar
Source103: tomcat-util-9.0.87.redhat-00003.jar
Source104: tomcat-util-9.0.87.redhat-00003.pom
Source105: tomcat-i18n-fr-9.0.87.redhat-00003.jar
Source106: tomcat-servlet-api-9.0.87.redhat-00003.pom
Source107: tomcat-catalina-9.0.87.redhat-00003.pom
Source108: tomcat-websocket-api-9.0.87.redhat-00003.pom
Source109: tomcat-jdbc-9.0.87.redhat-00003-sources.jar
Source110: tomcat-ssi-9.0.87.redhat-00003.pom
Source111: tomcat-ssi-9.0.87.redhat-00003-sources.jar
Source112: tomcat-9.0.87.redhat-00003-src.zip
Source113: tomcat-dbcp-9.0.87.redhat-00003.jar
Source114: tomcat-i18n-ja-9.0.87.redhat-00003.jar
Source115: tomcat-9.0.87.redhat-00003-docs.zip
Source116: tomcat-embed-core-9.0.87.redhat-00003.jar
Source117: tomcat-jni-9.0.87.redhat-00003.jar
Source118: tomcat-embed-el-9.0.87.redhat-00003.pom
Source119: tomcat-annotations-api-9.0.87.redhat-00003.jar
Source120: tomcat-util-scan-9.0.87.redhat-00003.jar
Source121: tomcat-parent-9.0.87.redhat-00003-project-sources.tar.gz
Source122: tomcat-embed-el-9.0.87.redhat-00003.jar
Source123: tomcat-el-api-9.0.87.redhat-00003-sources.jar
Source124: tomcat-jsp-api-9.0.87.redhat-00003.pom
Source125: tomcat-i18n-es-9.0.87.redhat-00003.jar
Source126: tomcat-embed-core-9.0.87.redhat-00003.pom
Source127: tomcat-parent-9.0.87.redhat-00003.pom
Source128: tomcat-jasper-9.0.87.redhat-00003-sources.jar
Source129: tomcat-bootstrap-9.0.87.redhat-00003.pom
Source130: tomcat-i18n-ja-9.0.87.redhat-00003.pom
Source131: tomcat-tribes-9.0.87.redhat-00003.pom
Source132: tomcat-websocket-api-9.0.87.redhat-00003-sources.jar
Source133: tomcat-catalina-ha-9.0.87.redhat-00003.pom
Source134: tomcat-websocket-api-9.0.87.redhat-00003.jar
Source135: tomcat-coyote-9.0.87.redhat-00003-sources.jar
Source136: tomcat-bootstrap-9.0.87.redhat-00003.jar
Source137: tomcat-util-scan-9.0.87.redhat-00003.pom
Source138: tomcat-api-9.0.87.redhat-00003-sources.jar
Source139: tomcat-jni-9.0.87.redhat-00003.pom
Source140: tomcat-embed-websocket-9.0.87.redhat-00003.pom
Source141: tomcat-coyote-9.0.87.redhat-00003.jar
Source142: tomcat-embed-jasper-9.0.87.redhat-00003-sources.jar
Source143: tomcat-coyote-9.0.87.redhat-00003.pom
Source144: tomcat-util-9.0.87.redhat-00003-sources.jar
Source145: tomcat-embed-jasper-9.0.87.redhat-00003.pom
Source146: tomcat-i18n-es-9.0.87.redhat-00003.pom
Source147: tomcat-jasper-el-9.0.87.redhat-00003-sources.jar
Source148: tomcat-jdbc-9.0.87.redhat-00003.jar
Source149: tomcat-api-9.0.87.redhat-00003.pom
Source150: tomcat-jaspic-api-9.0.87.redhat-00003-sources.jar
Source151: tomcat-storeconfig-9.0.87.redhat-00003.pom
Source152: tomcat-servlet-api-9.0.87.redhat-00003-sources.jar
Source153: tomcat-jsp-api-9.0.87.redhat-00003-sources.jar
Source154: tomcat-juli-9.0.87.redhat-00003.jar
Source155: tomcat-el-api-9.0.87.redhat-00003.jar
Source156: tomcat-ssi-9.0.87.redhat-00003.jar
Source157: tomcat-9.0.87.redhat-00003.pom
Source158: tomcat-dbcp-9.0.87.redhat-00003-sources.jar
Source159: tomcat-jasper-9.0.87.redhat-00003.pom
Source160: tomcat-util-scan-9.0.87.redhat-00003-sources.jar
Source161: tomcat-dbcp-9.0.87.redhat-00003.pom
Source162: tomcat-storeconfig-9.0.87.redhat-00003-sources.jar
Source163: tomcat-catalina-ant-9.0.87.redhat-00003-sources.jar
Source164: tomcat-bootstrap-9.0.87.redhat-00003-sources.jar
Source165: tomcat-catalina-ant-9.0.87.redhat-00003.pom
Source166: tomcat-juli-9.0.87.redhat-00003-sources.jar
Source167: tomcat-jsp-api-9.0.87.redhat-00003.jar
Source168: tomcat-9.0.87.redhat-00003-examples.zip
Source169: tomcat-catalina-ha-9.0.87.redhat-00003.jar
Source170: tomcat-embed-el-9.0.87.redhat-00003-sources.jar
Source171: tomcat-catalina-9.0.87.redhat-00003-sources.jar
Source172: tomcat-jasper-el-9.0.87.redhat-00003.jar
Source173: tomcat-embed-core-9.0.87.redhat-00003-sources.jar
Source174: tomcat-9.0.87.redhat-00003.zip
Source175: tomcat-annotations-api-9.0.87.redhat-00003-sources.jar
Source176: tomcat-catalina-ant-9.0.87.redhat-00003.jar
Source177: tomcat-i18n-fr-9.0.87.redhat-00003.pom
Source178: tomcat-tribes-9.0.87.redhat-00003-sources.jar
Source179: tomcat-catalina-9.0.87.redhat-00003.jar
Source180: tomcat-el-api-9.0.87.redhat-00003.pom
Source181: tomcat-servlet-api-9.0.87.redhat-00003.jar
Source182: tomcat-api-9.0.87.redhat-00003.jar
Source183: tomcat-jasper-9.0.87.redhat-00003.jar
Source184: tomcat-storeconfig-9.0.87.redhat-00003.jar
Source185: tomcat-websocket-9.0.87.redhat-00003.jar
Source186: tomcat-websocket-9.0.87.redhat-00003.pom
Source187: tomcat-tribes-9.0.87.redhat-00003.jar
Source188: tomcat-juli-9.0.87.redhat-00003.pom
Source189: tomcat-catalina-ha-9.0.87.redhat-00003-sources.jar
Source190: tomcat-annotations-api-9.0.87.redhat-00003.pom
Source191: tomcat-embed-jasper-9.0.87.redhat-00003.jar
Source192: tomcat-jaspic-api-9.0.87.redhat-00003.pom
Source193: tomcat-jasper-el-9.0.87.redhat-00003.pom
Source194: tomcat-embed-websocket-9.0.87.redhat-00003.jar
Source195: tomcat-jaspic-api-9.0.87.redhat-00003.jar
Source196: tomcat-embed-websocket-9.0.87.redhat-00003-sources.jar
Source197: tomcat-jdbc-9.0.87.redhat-00003.pom
Source198: tomcat-jni-9.0.87.redhat-00003-sources.jar
%endif

License: ASL 2.0
URL: http://tomcat.apache.org/

Source6:    %{pkg_name}-digest.sh
Source7:    %{pkg_name}-tool-wrapper.sh
# for SELinux
Source12:    %{pkg_name}.if

# systemd doesn't exist in versions before rhel7
%if 0%{?rhel} >= 7
Source1:     %{pkg_name}.el7.conf
Source3:     %{pkg_name}.el7.sysconfig
Source4:     %{pkg_name}.el7.wrapper
Source11:    %{pkg_name}.el7.te
Source13:    %{pkg_name}.el7.fc
Source17:    %{pkg_name}.service
Source18:    %{pkg_name}-functions
Source19:    %{pkg_name}-preamble
Source20:    %{pkg_name}-server
Source21:    %{pkg_name}-named.service
%else
Source1:     %{pkg_name}.el6.conf
Source3:     %{pkg_name}.el6.sysconfig
Source5:     %{pkg_name}.logrotate
Source11:    %{pkg_name}.el6.te
Source13:    %{pkg_name}.el6.fc
Source2:     %{pkg_name}.init
Source4:     %{pkg_name}.el6.wrapper
%endif

# The location of a JAR changed between el6 and el7,
# so there are two patches...
Patch0:    catalina-policy.patch

BuildRoot: %{_tmppath}/%{pkg_name}-%{version}-%{release}-root
BuildArch: noarch

BuildRequires: unzip
BuildRequires: %{?scl_prefix}ecj >= %{ecjrev}
BuildRequires: findutils
BuildRequires: %{?scl_prefix}javapackages-tools

%if 0%{?rhel} == 6
BuildRequires: java7-devel >= 0:1.7.0
%else
BuildRequires: java-devel >= 0:1.7.0
# Required for _unitdir macro expansion
BuildRequires: systemd-units
%endif

Requires(pre): shadow-utils
Requires(pre): shadow-utils
# Hackyness for JWS-1708
%if 0%{?rhel} > 7
Requires: (java-headless >= 1:1.8 or java-1.8.0-headless or java-11-headless or java-17-headless or java >= 1:1.8)
%endif
%if 0%{?rhel} == 7
Requires:  %{?scl_prefix}tomcat-java = %{epoch}:%{version}-%{release}
%endif
# Hackyness end
Requires: %{?scl_prefix}javapackages-tools
Requires: procps
Requires: %{name}-lib = %{epoch}:%{version}-%{release}
Requires(post):  chkconfig
Requires(preun): chkconfig
# Conditional for RHBZ#2012924 - redhat-lsb-core has been removed in RHEL9
%if 0%{?rhel} <= 8
Requires(post):  /lib/lsb/init-functions
Requires(preun): /lib/lsb/init-functions
%else
Requires(post):  /etc/os-release
Requires(preun): /etc/os-release
%endif
# End of conditional
Requires(post):   %{?scl_prefix}javapackages-tools
Requires(postun): %{?scl_prefix}javapackages-tools

%{?scl:Requires: %scl_runtime}

Obsoletes: %{name}-jsvc

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages specifications are developed by
Sun under the Java Community Process.

Tomcat is developed in an open and participatory environment and
released under the Apache Software License version 2.0. Tomcat is intended
to be a collaboration of the best-of-breed developers from around the world.

# Hackyness for JWS-1708
%if 0%{?rhel} == 7
%package java-jdk8
Group: Development/Java

Summary: Red Hat JBoss Web Server on JDK 8
Requires: java >= 1:1.8
Provides: %{?scl_prefix}tomcat-java = %{epoch}:%{version}-%{release}
Conflicts: java-jdk11

%description java-jdk8
JWS on JDK  8

%package java-jdk11
Group: Development/Java

Summary: Red Hat JBoss Web Server on JDK 11
Requires: java-11 >= 1:11
Provides: %{?scl_prefix}tomcat-java = %{epoch}:%{version}-%{release}
Conflicts: java-jdk8

%description java-jdk11
JWS on JDK  11
%endif
# Hackyness end

%package admin-webapps
Group: System Environment/Applications

Summary: The host-manager and manager web applications for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description admin-webapps
The host-manager and manager web applications for Apache Tomcat.

%package docs-webapp
Group: System Environment/Applications

Summary: The docs web application for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description docs-webapp
The docs web application for Apache Tomcat.

%package el-%{elspec}-api
Summary: Expression Language v%{elspec} API
Group: Development/Libraries/Java

Provides: el_api = %{elspec}
Obsoletes: %{name}-el-2.2-api
Requires(post):   %{?scl_prefix}javapackages-tools
Requires(postun): %{?scl_prefix}javapackages-tools
Requires: %{?scl_prefix}javapackages-tools

%description el-%{elspec}-api
Expression Language %{elspec} 

%package javadoc
Group: Documentation

Summary: Javadoc generated documentation for Apache Tomcat
Requires(pre): coreutils
Requires:      %{?scl_prefix}javapackages-tools
%global __requires_exclude jpackage-utils

%description javadoc
Javadoc generated documentation for Apache Tomcat.

%package jsp-%{jspspec}-api
Group: Internet/WWW/Dynamic Content

Summary: Apache Tomcat JSP API implementation classes
Provides: jsp = %{jspspec}
Obsoletes: %{name}-jsp-2.2-api
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-el-%{elspec}-api = %{epoch}:%{version}-%{release}
Requires(post):   %{?scl_prefix}javapackages-tools
Requires(postun): %{?scl_prefix}javapackages-tools
Requires: %{?scl_prefix}javapackages-tools

%description jsp-%{jspspec}-api
Apache Tomcat JSP API implementation classes.

%package lib
Group: Development/Compilers

Summary: Libraries needed to run the Tomcat Web container
Requires: %{name}-jsp-%{jspspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-el-%{elspec}-api = %{epoch}:%{version}-%{release}
Requires(post):   %{?scl_prefix}javapackages-tools
Requires(postun): %{?scl_prefix}javapackages-tools
Requires: %{?scl_prefix}javapackages-tools
Requires: %{?scl_prefix}ecj >= %{ecjrev}
Requires(preun): coreutils

%description lib
Libraries needed to run the Tomcat Web container.

%package servlet-%{servletspec}-api
Group: Internet/WWW/Dynamic Content

Summary: Apache Tomcat Servlet API implementation classes
Provides: servlet = %{servletspec}
Obsoletes: %{name}-servlet-3.1-api
Requires(post): %{?scl_prefix}javapackages-tools
Requires(postun): %{?scl_prefix}javapackages-tools
Requires: %{?scl_prefix}javapackages-tools

%description servlet-%{servletspec}-api
Apache Tomcat Servlet API implementation classes.

%package webapps
Group: System Environment/Applications

Summary: The ROOT web application for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description webapps
The ROOT web application for Apache Tomcat.

%if %with zips
%package zip
Summary:     Container for the zipped distribution of tomcat
Group:       Development


%description zip
Container for the zipped distribution of tomcat

%package src-zip
Summary:     Container for the sources
Group:       Development


%description src-zip
Container for the sources
%endif

%package selinux
Summary:        Selinux policy for tomcat
Group:          System Environment/Daemons

BuildRequires:  selinux-policy, selinux-policy-devel
%if 0%{?rhel} == 6
BuildRequires:  /usr/share/selinux/devel/policyhelp
%endif

%if "%{_selinux_policy_version}" != ""
Requires(pre):      selinux-policy-targeted >= %{_selinux_policy_version}
Requires(post):     selinux-policy-targeted >= %{_selinux_policy_version}
Requires(postun):   selinux-policy-targeted >= %{_selinux_policy_version}
%endif
Requires:           %{name} = %{version}-%{release}
%if "%{?rhel}" <= "7"
Requires(pre):      policycoreutils, policycoreutils-python, libselinux-utils
Requires(post):     policycoreutils, policycoreutils-python, libselinux-utils
Requires(postun):   policycoreutils, policycoreutils-python, libselinux-utils
%else
Requires(pre):      policycoreutils, python3-policycoreutils, libselinux-utils
Requires(post):     policycoreutils, python3-policycoreutils, libselinux-utils
Requires(postun):   policycoreutils, python3-policycoreutils, libselinux-utils
%endif

%description selinux
This is the selinux policy for tomcat.

%prep
echo Prep Phase

%setup -q -c -T

# Update paths in configuration files before installing them
# This allows any changes in SCL directories to be seamlessly consumed
sed -i 's|$datadir|%{_datadir}|g; s|$sysconfdir|%{_sysconfdir}|g; s|$sbindir|%{_sbindir}|g; s|$libexecdir|%{_libexecdir}|g; s|$localstatedir|%{_localstatedir}|g' %{_sourcedir}/*

# binary distribution
unzip %{_sourcedir}/%{pkg_name}-%{namedversion}.zip
# javadocs zip
unzip -d fulldocs %{_sourcedir}/%{pkg_name}-%{namedversion}-docs.zip

# Cleanup all of the windows resources
find . -type f -name "*.bat" -o -type f -name "*.pdf" | xargs -t -I{} %{__rm} {}

# Apply the policy patch to allow use of ecj jar
pushd apache-%{pkg_name}-%{namedversion}
%patch0 -p0
popd

%{__mkdir_p} selinux
%{__cp} -p %{SOURCE11} ./selinux/%{name}.te
%{__cp} -p %{SOURCE12} ./selinux/%{name}.if
%{__cp} -p %{SOURCE13} ./selinux/%{name}.fc

%build
echo Build Phase

pushd apache-%{pkg_name}-%{namedversion}
    # Remove jar from RPM distribution which uses the ECJ package
    %{__rm} lib/ecj-%{ecjrev}*.jar
popd

pushd selinux
  make -f %{_root_datadir}/selinux/devel/Makefile
  # we don't want to include tmp in the doc distribution
  %{__rm} -rf tmp
popd

%install
echo Install Phase

scl enable %{scl} - <<"SCLEOF"
%{__rm} -rf $RPM_BUILD_ROOT
# build initial path structure
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_javadocdir}/%{pkg_name}-%{version}
%{__ln_s} %{pkg_name}-%{version} ${RPM_BUILD_ROOT}%{_javadocdir}/%{pkg_name}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{appdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{bindir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}/Catalina/localhost
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{libdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{logdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{homedir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{tempdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{workdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sbindir}
%if 0%{?rhel} <= 6
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_root_sysconfdir}/logrotate.d
%endif

%if 0%{?rhel} >= 7
    %{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{_localstatedir}/lib/tomcats
    %{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_unitdir}
    %{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_libexecdir}/%{pkg_name}
    %{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}/conf.d
    /bin/echo "Place your custom *.conf files here. Shell expansion is supported." > ${RPM_BUILD_ROOT}%{confdir}/conf.d/README
%else
    %{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_root_initddir}
%endif

# move things into place
echo Install: Copy things into place

pushd apache-%{pkg_name}-%{namedversion}
    %{__cp} -a bin/*.{jar,xml} ${RPM_BUILD_ROOT}%{bindir}
    %{__cp} -a conf/*.{policy,properties,xml,xsd} ${RPM_BUILD_ROOT}%{confdir}
    %{__cp} -a lib/*.jar ${RPM_BUILD_ROOT}%{libdir}
    %{__cp} -a webapps/* ${RPM_BUILD_ROOT}%{appdir}
popd

# javadoc
pushd fulldocs/apache-%{pkg_name}-%{namedversion}/webapps/
    %{__cp} -a docs/api/* ${RPM_BUILD_ROOT}%{_javadocdir}/%{pkg_name}-%{version}
popd

%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE1} \
    > ${RPM_BUILD_ROOT}%{confdir}/%{pkg_name}.conf
%if 0%{?rhel} <= 6
    # JWS-741, remove after creating el specific conf files
    %{__sed} -i 's@ For shell expansion support@@g' ${RPM_BUILD_ROOT}%{confdir}/%{pkg_name}.conf
    %{__sed} -i 's@# place your custom files as %{_sysconfdir}/tomcat/conf.d/\*.conf@#@g' ${RPM_BUILD_ROOT}%{confdir}/%{pkg_name}.conf
%endif
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE3} \
    > ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{pkg_name}
%{__install} -m 0755 %{SOURCE4} \
    ${RPM_BUILD_ROOT}%{_sbindir}/%{pkg_name}
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE6} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{pkg_name}-digest
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE7} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{pkg_name}-tool-wrapper
%if 0%{?rhel} <= 6
%{__sed} -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g" %{SOURCE5} \
    > ${RPM_BUILD_ROOT}%{_root_sysconfdir}/logrotate.d/%{name}
%endif

%if 0%{?rhel} >= 7
%{__install} -m 0644 %{SOURCE17} \
    ${RPM_BUILD_ROOT}%{_unitdir}/%{name}.service
%{__install} -m 0644 %{SOURCE18} \
    ${RPM_BUILD_ROOT}%{_libexecdir}/%{pkg_name}/functions
%{__install} -m 0755 %{SOURCE19} \
    ${RPM_BUILD_ROOT}%{_libexecdir}/%{pkg_name}/preamble
%{__install} -m 0755 %{SOURCE20} \
    ${RPM_BUILD_ROOT}%{_libexecdir}/%{pkg_name}/server
%{__install} -m 0644 %{SOURCE21} \
    ${RPM_BUILD_ROOT}%{_unitdir}/%{name}@.service
%else
%{__install} -m 0755 %{SOURCE2} \
    ${RPM_BUILD_ROOT}%{_root_initddir}/%{name}
%endif

pushd ${RPM_BUILD_ROOT}%{libdir}
    # fix up jars to include version number
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
        %{__ln_s} ${j}.jar ${j}-%{version}.jar 
    done

    # ECJ
    %{__ln_s} $(scl enable jws5 'build-classpath ecj') ecj-%{ecjrev}-jws5.jar
popd

pushd ${RPM_BUILD_ROOT}%{_javadir}
    # symlink to maven components
    echo "Link maven components"
    #tomcat-jsp-api
    %{__ln_s} %{pkg_name}/jsp-api-%{version}.jar \
        %{pkg_name}-jsp-%{jspspec}-api-%{version}.jar
    # tomcat-servlet-api
    %{__ln_s} %{pkg_name}/servlet-api-%{version}.jar \
        %{pkg_name}-servlet-%{servletspec}-api-%{version}.jar
    # tomcat-el-api
    %{__ln_s} %{pkg_name}/el-api-%{version}.jar \
        %{pkg_name}-el-%{elspec}-api-%{version}.jar

    # extra links to satisfy what's defined for rpms
    %{__ln_s} %{pkg_name}-jsp-%{jspspec}-api-%{version}.jar %{pkg_name}-jsp-%{jspspec}-api.jar
    %{__ln_s} %{pkg_name}-servlet-%{servletspec}-api-%{version}.jar %{pkg_name}-servlet-%{servletspec}-api.jar
    %{__ln_s} %{pkg_name}-el-%{elspec}-api-%{version}.jar %{pkg_name}-el-%{elspec}-api.jar
popd

pushd ${RPM_BUILD_ROOT}%{bindir}
    # fix up jars to include version number
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
        %{__mv} ${j}.jar ${j}-%{version}.jar
        %{__ln_s} ${j}-%{version}.jar ${j}.jar
    done

popd

# symlink to the FHS locations where we've installed things
pushd ${RPM_BUILD_ROOT}%{homedir}
    %{__ln_s} %{appdir} webapps
    %{__ln_s} %{confdir} conf
    %{__ln_s} %{libdir} lib
    %{__ln_s} %{logdir} logs
    %{__ln_s} %{tempdir} temp
    %{__ln_s} %{workdir} work
popd

%if %with zips
echo Zips
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev
# Copy over source zip for the src-zip subpackage
%{__install} -p -m 0644 %{_sourcedir}/%{pkg_name}-%{namedversion}-src.zip ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-src.zip
# Copy over zip for the zip subpackage
%{__install} -p -m 0644 %{_sourcedir}/%{pkg_name}-%{namedversion}-docs.zip ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-docs.zip
%{__install} -p -m 0644 %{_sourcedir}/%{pkg_name}-%{namedversion}-examples.zip ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-examples.zip
%{__install} -p -m 0644 %{_sourcedir}/%{pkg_name}-%{namedversion}.zip ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}.zip
echo End Zips
%endif

install -d $RPM_BUILD_ROOT/%{_datadir}/selinux/packages/%{name}
install -p -m 644 selinux/%{name}.pp $RPM_BUILD_ROOT/%{_datadir}/selinux/packages/%{name}/%{name}.pp

# End scl usage
SCLEOF

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
# add the tomcat user and group
getent group tomcat >/dev/null || %{_root_sbindir}/groupadd -f -g %{tcuid} -r tomcat
if ! getent passwd tomcat >/dev/null ; then
    if ! getent passwd %{tcuid} >/dev/null ; then
        %{_root_sbindir}/useradd -r -u %{tcuid} -g tomcat -d %{homedir} -s /sbin/nologin -c "Apache Tomcat" tomcat
        # Tomcat uses a reserved ID, so there should never be an else
    fi
fi
exit 0

%post
# install but don't activate
%if 0%{?rhel} >= 7
%systemd_post %{name}.service
%else
/sbin/chkconfig --add %{name}
%endif

%pre javadoc
%{__rm} -rf %{_javadocdir}/%{pkg_name}

%preun
# clean tempdir and workdir on removal or upgrade
%{__rm} -rf %{workdir}/* %{tempdir}/*

%if 0%{?rhel} >= 7
# clean tempdir and workdir on removal or upgrade
%{__rm} -rf %{workdir}/* %{tempdir}/*
%systemd_preun %{name}.service
%else
if [ "$1" = "0" ]; then
    %{_root_initddir}/%{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
fi
%endif

%if 0%{?rhel} >= 7
%systemd_postun_with_restart %{name}.service
%endif

%pre selinux
# The %%selinux_relabel_pre macro expands incorrectly with SCL on el7
. /etc/selinux/config
_policytype=
if [ -z "${_policytype}" ]; then
  _policytype="targeted"
fi
if %{_root_sbindir}/selinuxenabled && [ "${SELINUXTYPE}" = "${_policytype}" ]; then
    [ -f %{_file_context_file_pre} ] || cp -f %{_file_context_file} %{_file_context_file_pre}
fi

%post selinux
# The following macros expand incorrectly with SCL on el7
# %%selinux_modules_install %%{_datadir}/selinux/packages/%%{name}/%%{name}.pp
# %%selinux_relabel_post
. /etc/selinux/config
_policytype=
if [ -z "${_policytype}" ]; then
  _policytype="targeted"
fi

%if 0%{?rhel} <= 6
    %{_root_sbindir}/semodule -n -s ${_policytype} -i %{_datadir}/selinux/packages/%{name}/%{name}.pp
%else
    %{_root_sbindir}/semodule -n -s ${_policytype} -X 200 -i %{_datadir}/selinux/packages/%{name}/%{name}.pp 
%endif

if %{_root_sbindir}/selinuxenabled && [ "${SELINUXTYPE}" = "${_policytype}" ]; then
    %{_root_sbindir}/load_policy
    if [ -f %{_file_context_file_pre} ]; then
        /sbin/fixfiles -C %{_file_context_file_pre} restore
        %if 0%{?rhel} <= 6
            /sbin/restorecon %{_initrddir}/%{name} &> /dev/null
        %endif
        rm -f %{_file_context_file_pre}
    fi
fi

%if 0%{?rhel} <= 6
    # mxi_port doesn't exist on rhel-6, so we need to allow tomcat to bind to 8005
    %{_root_sbindir}/semanage port -a -t http_port_t -p tcp 8005 > /dev/null 2>&1 || :
%endif

%postun selinux
# The following macros expand incorrectly with SCL on el7
# %%selinux_modules_uninstall %{name}
# %%selinux_relabel_post
if [ $1 -eq 0 ]; then
    . /etc/selinux/config
    _policytype=
    if [ -z "${_policytype}" ]; then
      _policytype="targeted"
    fi

    %if 0%{?rhel} <= 6
        /usr/sbin/semodule -n -r %{name} &> /dev/null || :
    %else
        /usr/sbin/semodule -n -X 200 -r %{name} &> /dev/null || :
    %endif
    if %{_root_sbindir}/selinuxenabled && [ "${SELINUXTYPE}" = "${_policytype}" ]; then
       %{_root_sbindir}/load_policy
       if [ -f %{_file_context_file_pre} ]; then
         /sbin/fixfiles -C %{_file_context_file_pre} restore
         rm -f %{_file_context_file_pre}
       fi
    fi

    %if 0%{?rhel} <= 6
        # mxi_port doesn't exist on rhel-6, so we need to cleanup the port we added in %%post
        %{_root_sbindir}/semanage port -d -t http_port_t -p tcp 8005 > /dev/null 2>&1 || :
    %endif
fi

%files
%defattr(0640,root,root,0750)
%attr(0755,root,root) %{_bindir}/%{pkg_name}-digest
%attr(0755,root,root) %{_bindir}/%{pkg_name}-tool-wrapper
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/%{pkg_name}
%if 0%{?rhel} <= 6
    %attr(0644,root,root) %config(noreplace) %{_root_sysconfdir}/logrotate.d/%{name}
%endif

%defattr(0640,root,tomcat,0750)
%dir %{basedir}
%attr(0751,root,tomcat) %dir %{homedir}
%dir %{confdir}
%attr(0770,root,tomcat) %dir %{confdir}/Catalina
%attr(0770,root,tomcat) %dir %{confdir}/Catalina/localhost
%if 0%{?rhel} >= 7
    %dir %{confdir}/conf.d
    %{confdir}/conf.d/README
%endif
%config(noreplace) %{confdir}/%{pkg_name}.conf
%config(noreplace) %{confdir}/catalina.policy
%config(noreplace) %{confdir}/catalina.properties
%config(noreplace) %{confdir}/logging.properties
%config(noreplace) %{confdir}/context.xml
%config(noreplace) %{confdir}/server.xml
%config(noreplace) %{confdir}/tomcat-users.xml
%{confdir}/tomcat-users.xsd
%config(noreplace) %{confdir}/jaspic-providers.xml
%{confdir}/jaspic-providers.xsd
%config(noreplace) %{confdir}/web.xml
# Tomcat needs to write to all of these dirs
%attr(0770,tomcat,tomcat) %dir %{cachedir}
%attr(0770,tomcat,tomcat) %dir %{tempdir}
%attr(0770,tomcat,tomcat) %dir %{workdir}
%attr(0770,tomcat,tomcat) %dir %{appdir}
# Slightly more restrictive group access (-w) on the logs
%attr(0750,tomcat,tomcat) %dir %{logdir}

%defattr(0644,root,root,0755)
%dir %{bindir}
%{bindir}/bootstrap-%{version}.jar
%{bindir}/bootstrap.jar
%{bindir}/catalina-tasks.xml
%{bindir}/tomcat-juli-%{version}.jar
%{bindir}/tomcat-juli.jar

%defattr(0640,root,root,0750)
%{homedir}/conf
%{homedir}/lib
%{homedir}/logs
%{homedir}/temp
%{homedir}/webapps
%{homedir}/work

%defattr(0755,root,root,0755)
%{_sbindir}/%{pkg_name}
%if 0%{?rhel} >= 7
    %attr(0644,root,root) %{_unitdir}/%{name}.service
    %attr(0644,root,root) %{_unitdir}/%{name}@.service
    %dir %{_libexecdir}/%{pkg_name}
    %dir %{_localstatedir}/lib/tomcats
    %{_libexecdir}/%{pkg_name}/functions
    %{_libexecdir}/%{pkg_name}/preamble
    %{_libexecdir}/%{pkg_name}/server
%else
    %{_root_initddir}/%{name}
%endif

%files webapps
%defattr(0640,tomcat,tomcat,0750)
%{appdir}/ROOT

%files admin-webapps
%defattr(0640,tomcat,tomcat,0750)
%{appdir}/host-manager
%{appdir}/manager
%config(noreplace) %{appdir}/manager/WEB-INF/web.xml
%config(noreplace) %{appdir}/manager/META-INF/context.xml
%config(noreplace) %{appdir}/host-manager/WEB-INF/web.xml
%config(noreplace) %{appdir}/host-manager/META-INF/context.xml

%files docs-webapp
%defattr(0640,tomcat,tomcat,0750)
%{appdir}/docs

%files el-%{elspec}-api
%defattr(0644,root,root,0755)
#%if 0%{?rhel} == 6
%{_javadir}/%{pkg_name}-el-%{elspec}-api-%{version}.jar
%{_javadir}/%{pkg_name}-el-%{elspec}-api.jar
#%endif
%dir %{libdir}
%{libdir}/el-api.jar
%{libdir}/el-api-%{version}.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{pkg_name}-%{version}
%{_javadocdir}/%{pkg_name}

%files jsp-%{jspspec}-api
%defattr(0644,root,root,0755)
#%if 0%{?rhel} == 6
%{_javadir}/%{pkg_name}-jsp-%{jspspec}-api-%{version}.jar
%{_javadir}/%{pkg_name}-jsp-%{jspspec}-api.jar
#%endif
%dir %{libdir}
%{libdir}/jsp-api.jar
%{libdir}/jsp-api-%{version}.jar

%files lib
%defattr(0644,root,root,0755)
%dir %{libdir}
%{libdir}/annotations-api.jar
%{libdir}/annotations-api-%{version}.jar
%{libdir}/catalina.jar
%{libdir}/catalina-%{version}.jar
%{libdir}/catalina-ant.jar
%{libdir}/catalina-ant-%{version}.jar
%{libdir}/catalina-ha.jar
%{libdir}/catalina-ha-%{version}.jar
%{libdir}/catalina-tribes.jar
%{libdir}/catalina-tribes-%{version}.jar
%{libdir}/catalina-ssi.jar
%{libdir}/catalina-ssi-%{version}.jar
%{libdir}/tomcat-jdbc.jar
%{libdir}/tomcat-jdbc-%{version}.jar
%{libdir}/tomcat-util.jar
%{libdir}/tomcat-util-%{version}.jar
%{libdir}/tomcat-api.jar
%{libdir}/tomcat-api-%{version}.jar
%{libdir}/ecj-%{ecjrev}-jws5.jar
%{libdir}/jasper.jar
%{libdir}/jasper-%{version}.jar
%{libdir}/jasper-el.jar
%{libdir}/jasper-el-%{version}.jar
%{libdir}/tomcat-coyote.jar
%{libdir}/tomcat-coyote-%{version}.jar
%{libdir}/tomcat-i18n-*.jar
%{libdir}/websocket-api.jar
%{libdir}/websocket-api-%{version}.jar
%{libdir}/jaspic-api.jar
%{libdir}/jaspic-api-%{version}.jar
%{libdir}/tomcat-websocket.jar
%{libdir}/tomcat-websocket-%{version}.jar
%{libdir}/tomcat-util-scan.jar
%{libdir}/tomcat-util-scan-%{version}.jar
%{libdir}/catalina-storeconfig.jar
%{libdir}/catalina-storeconfig-%{version}.jar
%{libdir}/tomcat-jni.jar
%{libdir}/tomcat-jni-%{version}.jar
%{libdir}/tomcat-dbcp.jar
%{libdir}/tomcat-dbcp-%{version}.jar

%files servlet-%{servletspec}-api
%defattr(0644,root,root,0755)
%{_javadir}/%{pkg_name}-servlet-%{servletspec}-api-%{version}.jar
%{_javadir}/%{pkg_name}-servlet-%{servletspec}-api.jar
%dir %{libdir}
%{libdir}/servlet-api.jar
%{libdir}/servlet-api-%{version}.jar

%if %with zips
%files zip
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{pkg_name}-fordev
%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-docs.zip
%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-examples.zip
%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}.zip

%files src-zip
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{pkg_name}-fordev
%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-src.zip
%endif

%files selinux
%defattr(-,root,root,-)
%dir %{_datadir}/selinux
%dir %{_datadir}/selinux/packages
%dir %{_datadir}/selinux/packages/%{name}
%{_datadir}/selinux/packages/%{name}/%{name}.pp
%doc selinux/*

%if 0%{?rhel} == 7
%files java-jdk8

%files java-jdk11
%endif

%changelog
* Wed Apr 03 2024 Sokratis Zappis <szappis@redhat.com> - 9.0.87-1.redhat_00001.1
- Resolves: [JWS-3231] - Rebase tomcat to version 9.0.87

* Tue Feb 27 2024 Sokratis Zappis <szappis@redhat.com> - 9.0.62-41.redhat_00020.1
- 5.7.8.CR1

* Tue Feb 13 2024 Sokratis Zappis <szappis@redhat.com> - 9.0.62-40.redhat_00019.1
- 5.7.8.DR1

* Wed Nov 15 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-19.redhat_00017.1
- 5.7.7.CR1

* Fri Oct 20 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-17.redhat_00015.1
- 5.7.6.CR1

* Wed Oct 11 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-16.redhat_00014.1
- 5.7.5.CR1

* Fri Jul 28 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-15.redhat_00013.1
- 5.7.4.CR2

* Mon Jul 17 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-14.redhat_00012.1
- 5.7.4.CR1

* Thu Mar 30 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-13.redhat_00011.1
- 5.7.2.CR3

* Mon Mar 27 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-12.rehdat_00010.1
- 5.7.2.CR2

* Tue Mar 07 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-11.redhat_00008.1
- 5.7.2.CR1

* Tue Feb 21 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-10.redhat_00007.1
- 5.7.2.DR1

* Tue Oct 18 2022 Sokratis Zappis <szappis@redhat.com> - 9.0.62-9.redhat_00005.1
- Supplemental fix for JWS-2618 avoid xorg dependency through java package in JWS rpms

* Fri Sep 23 2022 Hui Wang <huwang@redhat.com> - 9.0.62-7.redhat_00004.1
- Resolves: JWS-2618 avoid xorg dependency through java package in JWS rpms

* Wed Aug 25 2022 Sokratis Zappis <szappis@redhat.com> - 9.0.62-6.redhat_00003.1
- Resolves: JWS-1467 Upgrade ECJ to latest available version

* Tue Jul 26 2022 Sokratis Zappis <szappis@redhat.com> - 9.0.62-4.redhat_00002.1
- Adding conditional for RHEL9 build due to RHBZ#2012924

* Tue Apr 27 2021 Hui Wang <huwang@redhat.com> - 9.0.43-8.redhat_8.1
- Related: JWS-1665 clean up the unnecessary references

* Thu Mar 18 2021 Hui Wang <huwang@redhat.com> - 9.0.43-6.redhat_6.1
- Resolves: JWS-1708 JWS5 requires Java8

* Tue Mar 16 2021 Sokratis Zappis <szappis@redhat.com> - 9.0.43-5.redhat_5.1
- Build for JWS 5.5.0.ER2

* Thu Mar 11 2021 Hui Wang <huwang@redhat.com> - 9.0.43-4.redhat_4.1
- Resolves: JWS-1708 JWS5 requires Java8

* Thu Mar 04 2021 Hui Wang <huwang@redhat.com> - 9.0.43-2.redhat_2.1
- Related: JWS-1665 bndlib is not needed

* Tue Mar 02 2021 Hui Wang <huwang@redhat.com> - 9.0.43-1.redhat_1.1
- Update to 9.0.43

* Fri Jan 15 2021 Sokratis Zappis <szappis@redhat.com> - 9.0.36-9.redhat_8.1
- Rebuilding

* Thu Jan 14 2021 Sokratis Zappis <szappis@redhat.com> - 9.0.36-8.redhat_7.1
- Rebuilding

* Thu Jan 14 2021 Hui Wang <huwang@redhat.com> - 9.0.36-7.redhat_6.1
- Resolves: JWS-1858 CVE-2020-13943 tomcat: Apache Tomcat HTTP/2 Request mix-up [jws-5]
- Resolves: JWS-1894 CVE-2020-17527 tomcat: HTTP/2 request header mix-up [jws-5]

* Tue Sep 15 2020 Coty Sutherland <csutherl@redhat.com> - 9.0.36-6.redhat_5.2
- Resolves: JWS-1739 unable to make tomcat9/jws5 FIPS-compliant with NSS

* Tue Sep 15 2020 Coty Sutherland <csutherl@redhat.com> - 9.0.36-5.redhat_5.1
- Resolves: JWS-1739 unable to make tomcat9/jws5 FIPS-compliant with NSS

* Fri Sep 11 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.36-4.redhat_4.1
- Resolves: JWS-1828 o.a.c.valves.HealthCheckValve returns 404 incorrectly

* Tue Sep 08 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.36-3.redhat_3.1
- Update sources

* Fri Jul 17 2020 Hui Wang <huwang@redhat.com> - 9.0.36-2.redhat_2.1
- Resolves: JWS-1750 CVE-2020-13934 tomcat: OutOfMemoryException caused by HTTP/2 connection leak could lead to DoS [jws-5.4] 
- Resolves: JWS-1751 CVE-2020-13935 tomcat: multiple requests with invalid payload length in a WebSocket frame could lead to DoS [jws-5.4]

* Thu Jun 25 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.36-1.redhat_1.1
- Rebuild

* Tue Mar 31 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.30-3.redhat_4.1
- 5.3.0.CR1
- Resolves: JWS-1592 Missing jar file in maven repository
- Resolves: JWS-1598 Storing configuration fails with java.lang.NoSuchMethodException

* Tue Mar 10 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.30-2.redhat_3.1
- 5.3.0.ER1

* Tue Feb 25 2020 Coty Sutherland <csutherl@redhat.com> - 9.0.30-2.redhat_3.1
- Related: JWS-1585 Refactor secret check
- Resolves: Add missing changelog entries

* Tue Feb 11 2020 Coty Sutherland <csutherl@redhat.com> - 9.0.30-1.redhat_2.1
- 5.3.0.DR1
- Remove jbcs-httpd24-javapackages-tools BuildRequires
- Resolves: JWS-1468 Rebase Tomcat to version 9.0.30
- Resolves: JWS-1478 rpm install/update overwrites context.xml for host-manager and manager applications
- Resolves: JWS-1500 CVE-2019-12418 tomcat: local privilege escalation
- Resolves: JWS-1502 CVE-2019-17563 tomcat: session fixation
- Resolves: JWS-1419 java-headless requirement forces OpenJDK install
- Resolves: JWS-1589 CVE-2019-17569 tomcat: Regression in handling of Transfer-Encoding header allows for HTTP request smuggling
- Resolves: JWS-1587 CVE-2020-1935 tomcat: Mishandling of Transfer-Encoding header allows for HTTP request smuggling
- Resolves: JWS-1585 CVE-2020-1938 ajp: tomcat: Apache Tomcat AJP File Read/Inclusion Vulnerability

* Wed Oct 16 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-10.redhat_4.1
- 5.2.0.ER2
- Related: JWS-1430 Correct conf changes

* Thu Aug 29 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-9.redhat_3.2
- 5.2.0.DR2

* Fri Aug 16 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-7.redhat_2.1
- Resolves: JWS-1435 Drop jsvc support
- Resolves: JWS-1430 RPM shutdown throws warnings with Java 11

* Fri Aug 02 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-6.redhat_2.1
- Rebuild tomcat to include new ECJ version and remove commons-daemon

* Tue Jul 16 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-5.redhat_1.1
- 5.2.0.DR1
- Resolves: JWS-1426 Remove broken alternatives post-install scriptlets on RHEL 8
- Resolves: JWS-1417 CVE-2019-10072 tomcat: HTTP/2 implementation leads to denial of service
- Resolves: JWS-1367 CVE-2019-0232 tomcat: Remote Code Execution on Windows
- Resolves: JWS-1402 CVE-2019-0221 tomcat: XSS in SSI printenv
- Resolves: JWS-1318 CVE-2019-0199 tomcat: Apache Tomcat HTTP/2 DoS

* Mon Jul 15 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-4.redhat_1.1
- More selinux fixes

* Fri Jul 12 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-3.redhat_1.1
- Updates to selinux policy

* Thu Jul 11 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-2.redhat_1.1
- 5.2.0.DR1, selinux changes

* Mon Jun 17 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-1.redhat_1.1
- Cleanup some outdated information in spec subpackages
- Resolves: JWS-1361 SELinux policy enhancements and fixes

* Fri Apr 05 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-20.redhat_17.1
- Rebuild
- Related: JWS-1341 Remove commons-daemon.jar until it is removed from the tomcat zip and package logrotate in rhel-6 only

* Thu Apr 04 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-20.redhat_16.1
- Correcting catalina-policy.patch format

* Thu Apr 04 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-20.redhat_16.1
- Remove commons-daemon dependency

* Thu Apr 04 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-20.redhat_16.1
- Resolves: JWS-1341

* Thu Mar 14 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-19.redhat_16.1
- JWS-1332 attempt 2

* Wed Mar 13 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-18.redhat_16.1
- Resolves: JWS-1332

* Thu Nov 29 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-17.redhat_16.1
- Build with dynamic suffix, attempt two

* Thu Nov 29 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-17.redhat_16.1
- Resolves: JWS-1290 Several pom.xml files are invalid according to Maven POM XSD

* Mon Nov 26 2018 Georgios Zaronikas- Karagiannis <gzaronik@redhat.com> - 9.0.7-16.redhat_15.1
- JWS 5.0.2 ER1

* Fri Nov 09 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-15.redhat_14.1
- Bump tomcat GAV version

* Thu Nov 08 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-14.redhat_13.1
- 5.0.2.DR1, attempt 2. Disable javadocs failonwarning

* Mon Nov 05 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-14.redhat_13.1
- Resolves: JWS-1098 CVE-2018-8034 tomcat: host name verification missing in WebSocket client
- Resolves: JWS-1068 CVE-2018-8014 tomcat: Insecure defaults in CORS filter enable 'supportsCredentials' for all origins
- Resolves: JWS-1074 Use GMT in expires date format
- Resolves: JWS-1153 Body text property replacement fails
- Resolves: JWS-1072 Missing handshake timeouts for NIO 2 and NIO 2 timeout improvements
- Resolves: JWS-1080 Error page processing regression
- Resolves: JWS-1128 Improve the handling of path parameters with request dispatcher
- Resolves: JWS-1160 Tomcat Host Manager incorrectly saves connector with SSL configuration
- Resolves: JWS-1123 Better embedded support and user experience for native
- Resolves: JWS-1164 Add some substitution recursive parsing for rewrite
- Resolves: JWS-1070 Unexpected handshake failures with OpenSSL
- Resolves: JWS-1069 Avoid error pages in some cases
- Resolves: JWS-1073 NIO 2 fixes affecting IO API reliability
- Resolves: JWS-1071 Java 11 support for annotation scanning
- Resolves: JWS-1018 Relax Host validation by removing the requirement that the final component of a FQDN must be alphabetic

* Wed Oct 10 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-13.redhat_12.1
- Resolves: JWS-1159 Update %%{_sysconfdir} and %%{_localstatedir} in RPM configuration files
- Resolves: JWS-1158 Update reference to java-functions

* Fri Sep 07 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-12.redhat_12.1
- Fix the redhat version suffix

* Wed Sep 05 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-11.redhat_11.1
- JWS_5.0.0.SP1_ER1
- Resolves: JWS-996 Connection leak during XATransaction in high load
- Resolves: JWS-1028 Failures in jBPM embedded use case with H2 database
- Resolves: JWS-1064 Update the Tomcat fork of Commons DBCP 2 to 2.4.0
- Resolves: JWS-1065 Tomcat Commons Pool Update
- Resolves: JWS-1121 Update the internal fork of Apache Commons DBCP 2 to abc0484 (2018-08-09) to pick up some bug fixes and enhancements
- Resolves: JWS-1124 ARJUNA016082: Synchronizations are not allowed! Transaction status isActionStatus.RUNNING when running jBPM engine in KIE server deployed to Tomcat
- Resolves: JWS-1125 CVE-2018-1336 tomcat: Improve handing of overflow in the UTF-8 decoder with supplementary characters
- Resolves: JWS-1132 CVE-2018-11784 tomcat: Avoid protocol relative redirects in default servlet
- Resolves: JWS-1099 CVE-2018-8037 tomcat: Due to a mishandling of close in NIO/NIO2 connectors user sessions can get mixed up

* Wed Jun 06 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-10.redhat_10.1
- JWS-5.0.0.RHEL_CR1
- Resolves: JWS-1024 Tomcat's Digester tries to use a non-initialized variable causing a NPE
- Resolves: JWS-996 Connection leak during XATransaction in high load

* Fri May 18 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-9.redhat_9.1
- Related: JWS-995 Tweaking maven dependencies at bit

* Tue May 15 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-8.redhat_8.1
- Building without the embed zip

* Tue May 15 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-7.redhat_7.1
- Build for JWS-5.0.0.RHEL_ER2

* Thu May 03 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-7.redhat_6.1
- Related: JWS-967 Remove jpackages-util dep from javadoc subpackage

* Tue May 01 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-6.redhat_6.1
- Rebuild to include fix for JWS-991

* Tue May 01 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-5.redhat_5.1
- Rebuild for JWS-521 and JWS-991

* Tue May 01 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-5.redhat_4.1
- Related: JWS-521 Hardcode path to commons-daemon after JWS-968 broke jsvc

* Mon Apr 16 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-4.redhat_4.1
- Resolves: JWS-972 Enable the configuration of multiple properties files
- Resolves: JWS-973 Add system property expansion support for properties files

* Thu Apr 12 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-3.redhat_2.1
- Resolves: JWS-727 Cleanup selinux packages dir on uninstall
- Resolves: JWS-681 Change java requirement for tomcat to headless
- Resolves: JWS-968 common-daemon jar symlink contains wrong version in name
- Resolves: JWS-771 tomcat-tool-wrapper is missing tomcat-api.jar on the CLASSPATH
- Resolves: JWS-770 tomcat-digest missing tomcat-api.jar at CLASSPATH

* Wed Apr 11 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-2.redhat_2.1
- Resolves: JWS-599 Tomcat ServerInfo update to reflect redhat version string
- Resolves: JWS-967 jpackage-utils RPM dependency should be updated to use the jws5-javapackages-tools package

* Wed Apr 11 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-1.redhat_1.1
- Rebase to Tomcat 9.0.7

* Mon Apr 09 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.6-2.redhat_2.2
- Resolves: JWS-965 tomcat doesn't start via jws5-tomcat service

* Tue Mar 20 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.6-1.redhat_1.1
- Rebase to Tomcat 9.0.6

* Tue Feb 27 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.5-2.redhat_2.2
- Resolves: JWS-822 man page uid and gid mismatch for service accounts
- Resolves: JWS-817 SELinux denies name_bind to jboss_management_port_t for tomcat_t
- Resolves: JWS-818 SELinux denies name_connect to mysql_port_t for tomcat_t
- Resolves: JWS-819 SELinux denies name_connect to mssql_port_t for tomcat_t
- Resolves: JWS-844 Problem to start tomcat with a user whose group has a name different to the user
- Resolves: JWS-845 tomcat-jsvc.service has TOMCAT_USER value hard-coded
- Resolves: JWS-864 tomcat systemd does not cope with - in service names

* Tue Feb 20 2018 Patrick Sutherland <csutherl@redhat.com> - 9.0.5-1.redhat_2.1
- Attempt #2

* Tue Feb 20 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.5.redhat_1.1
- JWS_5.0.0.DR1
